/******************************
*							  *
*	Troff Player Routines	  *	
*							  *
*	by Vova and Serge		  *	
*	March 2001			      *
*	sorok@btinternet.com      *
*							  *
******************************/

u8 pattern_tmp=0, fade0=0, fade1=0, repetition=0;
u16 song_counter=0, pattern_id=0, song_tempo;


void InitSound(u8 channels, u8 volume) {//How many channels will be used. Max is 2 at the moment
										//Volume 0-7
	if (channels==2) channels=3;
	if (channels>3) channels=3;

	*(u16*)0x4000082 = 0x0002;
	*(u16*)0x4000084 = 0x0080;
	*(u16*)0x4000080 = 0x3377;//volume+volume*16+channels*256+4096*channels;
	*(u16*)0x4000060 = 0x0008;
	*(u16*)0x4000062 = 0x0030;
	*(u16*)0x4000064=32768;
	if (channels>1) {
		*(u16*)0x4000068 = 0x0030;
		*(u16*)0x400006c = 32768;
	}

}

void InitSong(u16 tempo, u8 rep) {

	song_tempo=tempo;
	repetition=rep;

}

void PlayNote(u8 channel, u16 note) {

	if (channel==0) *(u16*)0x4000064=note;
	if (channel==1) *(u16*)0x400006c=note;

}

void Fade(u8 channel, u8 level) {

	if (channel==0) *(u16*)0x4000062 = 0x0030+level*4096;
	if (channel==1) *(u16*)0x4000068 = 0x0030+level*4096;

}

void Balance(u8 channels, u8 left_balance, u8 right_balance) {// 0-7. Channels means number of channels used

	*(u16*)0x4000080 = right_balance+left_balance*16+channels*256+4096*channels;

}

void PlayPattern(u16 pattern) {

	if (pattern0[song_patterns[pattern]*64+pattern_tmp]!=0) PlayNote(0, pattern0[song_patterns[pattern]*64+pattern_tmp]);
	if (pattern1[song_patterns[pattern]*64+pattern_tmp]!=0) PlayNote(1, pattern1[song_patterns[pattern]*64+pattern_tmp]);

}	

void UpdateSong() {

	song_counter++;

	if (song_counter==song_tempo) {
		PlayPattern(pattern_id);
		song_counter=0;
		if (pattern0[song_patterns[pattern_id]*64+pattern_tmp]==0 && fade0!=0) {
			fade0--;
			Fade(0, fade0);
		}
		if (pattern1[song_patterns[pattern_id]*64+pattern_tmp]==0 && fade1!=0) {
			fade1--;
			Fade(1, fade1);
		}
		if (pattern0[song_patterns[pattern_id]*64+pattern_tmp]!=0 && fade0!=15) {
			fade0=15;
			Fade(0, fade0);
		}
	
		if (pattern1[song_patterns[pattern_id]*64+pattern_tmp]!=0 && fade1!=15) {
			fade1=15;
			Fade(1, fade1);
		}
		pattern_tmp++;
		if (pattern_tmp>63) {
			pattern_tmp=0;
			pattern_id++;
			if (pattern_id==song_length) pattern_id=0;
		}
	}
}
